

```python
%matplotlib inline
import matplotlib.cm as cm
import matplotlib.pyplot as plt
import sys 
import numpy as np
from collections import defaultdict
import statsmodels.api as sm
from wordcloud import WordCloud
import jieba
import matplotlib
import gensim
from gensim import corpora, models, similarities
from gensim.utils import simple_preprocess
from gensim.parsing.preprocessing import STOPWORDS
matplotlib.rcParams['font.sans-serif'] = ['Microsoft YaHei'] #指定默认字体 
matplotlib.rc("savefig", dpi=400)
```


```python
with open('C:/Users/abner/github/data/gov_reports1954-2016.txt', 'r') as f:
    reports = f.readlines()
```


```python
len(reports)
```




    48




```python
print reports[32][:1000]
```

    2002	2002年政府工作报告　　——2002年3月5日在第九届全国人民代表大会第五次会议上		　　　　　　　　　　　　　　　　　　 国务院总理朱镕基　  各位代表：　　现在，我代表国务院向大会作政府工作报告，请予审议，并请全国政协各位委员提出意见。　　首先报告２００１年的工作。　　新世纪第一年，全国各族人民在中国共产党领导下，面对复杂多变的国际形势，克服困难，阔步前进，改革开放和社会主义现代化建设取得了新的重大成就。　　国民经济保持良好发展势头。在世界经济增长明显减速的情况下，我们坚持扩大内需的方针，坚定地实施积极的财政政策和稳健的货币政策，实现了经济较快增长。２００１年国内生产总值达到９５９３３亿元，比上年增长７．３％。经济结构调整取得积极进展。农业结构有所优化，优质、专
    


```python
# 为了确保中文可以在matplotlib里正确显示
matplotlib.rcParams['font.sans-serif'] = ['Microsoft YaHei'] #指定默认字体 
# 需要确定系统安装了Microsoft YaHei
```


```python
#分词
import jieba

seg_list = jieba.cut(reports[0][:30], cut_all=False)
print("Full Mode: " + "/ ".join(seg_list))
```

    Full Mode: 1954/ 	/ 1954/ 年/ 政府/ 工作/ 报告
    


```python
filename = 'C:/Users/abner/github/data/stopwords.txt'
stopwords = {}
f = open(filename, 'r')
line = f.readline().rstrip()
while line:
    stopwords.setdefault(line, 0)
    stopwords[line.decode('utf-8')] = 1
    line = f.readline().rstrip()
f.close()
```


```python
def wordcloudplot(txt, year):
    wordcloud = WordCloud(font_path='C:/Users/abner/github/data/msyh.ttf').generate(txt)
    # Open a plot of the generated image.
    plt.imshow(wordcloud)
    plt.title(year)
    plt.axis("off")
    #plt.show()
```


```python
txt = reports[-1]
seg_list = jieba.cut(txt, cut_all=False)
seg_list = [i for i in seg_list if i not in stopwords]
txt = r' '.join(seg_list)
wordcloudplot(txt, txt[:4]) 
```

    C:\Users\abner\Anaconda2\lib\site-packages\matplotlib\font_manager.py:1288: UserWarning: findfont: Font family [u'sans-serif'] not found. Falling back to Bitstream Vera Sans
      (prop.get_family(), self.defaultFamily[fontext]))
    


![png](output_8_1.png)



```python
import jieba.analyse

wordset = []
for txt in reports:
    top20= jieba.analyse.textrank(txt, topK=200, withWeight=False)
    for w in top20:
        if w not in wordset:
            wordset.append(w)
```


```python
len(wordset)
```




    1302




```python
print ' '.join(wordset)
```

    国家 人民 工业 发展 建设 工作 生产 美国 企业 经济 计划 社会主义 中国 进行 全国 技术 亚洲 集团 需要 问题 农业 方面 完成 建立 台湾 生活 事业 没有 改造 应当 资本主义 增加 关系 组织 保证 会议 侵略 不能 注意 加强 战争 提高 社会 文化 继续 政府 现代化 能够 日内瓦 世界 东南亚 运动 起来 参加 苏联 少数民族 协议 管理 浪费 实行 群众 机关 采取 解决 得到 制度 现象 条约 改善 领导 资金 革命 集体 职工 任务 政策 地方 增长 斗争 商业 工作人员 合作 情况 农民 规定 恢复 日本 卖国 法律 比重 解放 物质 实现 劳动 原则 改进 力量 城市 工程 时期 破坏 企图 朝鲜 研究 印度支那 总产值 帮助 地区 扩大 重工业 保障 合理 教育 产品 财政 作用 依靠 才能 民主 成为 巩固 华侨 中央 任意 培养 收购 制造厂 要求 分子 供应 权利 代表 粮食 包括 棉花 基础 推广 使用 表现 节约 国际 水平 损失 公私合营 行政 全部 宪法 防务 忽视 防洪 人才 不够 产量 思想 容许 国民经济 还有 等于 准备 加以 时候 希望 干涉 大家 商品 民族 经验 大陆 适应 胜利 不顾 领土 五年计划 克服 中华人民共和国 设备 工业化 决定 达到 活动 国营商业 势力 缺点 加紧 有关 联系 支持 已有 满足 指导 开展 发挥 市场 独立 铁路 昌都地区 保卫 部门 正义 知识分子 应该 可能 投资 增产 单位 设计 工人 条件 制造 形式 建成 原料 手工业 工厂 开始 办法 资本家 规模 新建 农村 例如 过渡时期 认为 工业生产 干部 大量 职员 施工 减少 学习 土地 帝国主义 利用 援助 数量 限额 人员 指标 厂矿 加工 汽车 种类 速度 工人阶级 原有 学校 质量 科学技术 方针 政治 轻工业 错误 措施 定货 合作化 改变 经营 统治 接受 周转量 试制 改建 材料 个体 道路 工业品 面积 积极性 薯类 产值 重点 实际 建筑 促进 水利 所有制 消费品 总任务 历史 掌握 非生产性 标准 比例 预算 支出 收入 部分 执行 国营 立井 公路 项目 税收 总数 片面 数字 价格 钢材 扣除 国营企业 预计 收支 状况 兰州 拨付 货物 水库 工业部 降低 可比 过程 储备 包头 决算 铺轨 军备 超过 新疆 去年同期 统计 获得 用于 农户 经费 水利工程 修建 开支 数额 物资 公方 电厂 调整 结果 投入 鹤岗 信贷资金 工资 月份 利润 建筑安装 设法 自筹 贯通 发生 乡村 费用 影响 预备 收到 通车 中央预算 年收入 零售总额 变化 住宅 是否 西藏 全面 机器设备 银行 淮河 附加 煤炭 灌溉面积 奖励制度 联合 水泥 分配 科学 基本 资产阶级 提出 存在 右派分子 取得 日益 学生 工农 条例 集中 科学家 机构 科学研究 建议 性质 批判 委员会 意见 成绩 官僚主义 队伍 人口 偏差 草案 宗派主义 个别 科学事业 立场 规划 民主党派 制订 改革 工农业 阶级 选举 否定 说明 提倡 留学生 毕业生 殖民主义 剥削 造成 态度 只能 变为 成果 业务 基本上 学徒 派遣 实践 争取 控制 批评 表示 运输 鼓掌 跃进 服务 相结合 战线 统一 全世界 阵营 结合 制造业 劳动力 共产主义 方法 威胁 出现 叛乱 人们 总路线 定期 公社 非洲 发动 维护 愿意 军事 自治区 利益 岸信 武装 祖国 失败 西藏地方 帝国主义者 安排 自治 讨论 时间 挑拨 证明 复活 知道 作为 受到 纲要 食堂 提前 消灭 机械化 危害 防治 举办 社办 效益 做到 坚持 养猪 农具 改良 公布 病虫害 社员 扑灭 办好 大会 棉田 群众性 过渡 八字宪法 麻雀 种子 全体 纲领 大办 保持 耕地 灌溉 科学试验 动员 充分发挥 分配制度 精耕细作 农作物 程度 负担 事情 家庭 臭虫 修改 血吸虫病 同志 施肥 修好 养鹅 水稻 养鸭 灭病 养鸡 号召 节约用粮 牲畜 工具 广东省 佛山市 指出 加快 渔业生产 掀起 合一 内容 托儿所 化肥厂 穷队 普及 地块 水土 总产量 土壤 创造 普查 制定 小学 识字 耕作 种得 树冠 兴办 鼠疫 分析 水灾 山区 作风 善于 范围 治疗 反动派 修正主义 认识 马克思列宁主义 毛主席 精神 反帝 支援 复辟 核武器 印度 意义 拉丁美洲 处理 革命化 品种 外国 成就 符合 称号 燃料 具有 阴谋 深入 相信 西藏自治区 走狗 亚非 大寨 增强 主任委员 观点 为首 进攻 民族团结 反动 食糖 筹委会 总结 有所 爱国 防止 总理 锡兰 推行 自然界 举行 有着 民族主义 刚果 报告 提供 不会 路线 马克思主义 被压迫 边界 批林批孔 专政 武装冲突 争议地区 领域 争夺 武力 接触 理论 老干部 正确处理 中苏 脱离 争论 双方 有利于 包含 选拔 粉碎 两国 设想 倾向 妇女干部 军队 文艺 广积粮 反霸 颠覆 认真执行 广大干部 方向 谅解 拒绝 签订 继续执行 断言 有力 国际形势 回答 埋葬 推动 试验 爱国人士 称霸 战备 奴隶 柬埔寨 美苏 背弃 直至 越南 挑起 角落 打击 玩弄 打仗 教条主义 领导岗位 优秀分子 担负 人类 光荣任务 保卫祖国 外交 光荣传统 谈判 为主 备战 民主集中制 欧洲 工农兵 打倒 主力军 洋奴哲学 空洞 动荡 内债 歼灭 敢于 强国 教导 搞好 基地 大力 敌人 指示 社队 抓好 加速 妄图 战胜 重视 两国人民 中心 高速度 保护 树立 居住 召开 发扬 做好 苏美 污蔑 霸权主义 无政府主义 事业单位 秩序 负责 引进 法制 纪律 当局 生产力 管理体制 安定团结 就业 原材料 资源 农副产品 试行 动力 纠正 允许 义务 现有企业 机械 试点 开发 结构 能源 效果 自主权 竞争 勘探 调查 流通 协作 海域 节能 观念 打破 缝纫机 节约能源 奖金 季节 入学 自销 积累 作出 自行车 进展 购买力 货运量 行业 总量 交通 经济作物 前进 来源 增长速度 能耗 广播 共生矿 毕业 校舍 港口 电视 生产能力 石油 调动 总额 提高质量 棉纱 沼气 煤矿 综合 化工 劳动者 优先 工业锅炉 经济效益 责任制 物价 国民收入 能力 放在 财政收入 方式 出口 下降 手段 信贷 关心 不得 经济体制 违反 建设项目 煤田 不合理 全局 女婴 严格控制 依法 确定 体制 应用 城乡 出版 形势 抓紧 鼓励 科技 政法 作品 艺术 国防 前提 消除 体育 上交 职业 个人 财力 对立 成本 承包 主张 香港 五项原则 公司 赞成 审批 科研 包干 裁军 社会制度 招标 承担 交流 建筑业 供销社 利改税 经济特区 监督 工期 遵循 地位 相应 厂长 磋商 投标 地步 贸易中心 购销 消费 工资制度 基金 补贴 消费基金 搞活 货币 工资总额 基数 考虑 出发 追求 增多 核定 决不能 消费者 部署 盲目 产业结构 价格体系 协调 城镇 宏观经济 献计 建材 持续增长 幅度 增加收入 商品经济 调节 进入 专业银行 前景 劳动生产率 因素 购买 乱提 金融 决策 联产承包 放开 长远利益 完善 运用 进口 贸易 外汇 投资规模 转变 系统 体系 引导 出口创汇 转向 战略 里程 行为 活力 局面 劳务 共培养 自由化 开放 思潮 推进 特色 增产节约 增收节支 探索 不变 横向 纳入 差额 轨道 相适应 经营机制 产品质量 目标 实施 形成 看到 外贸 理顺 职能 基层 环境 经营责任制 素质 压缩 需求 治理 制止 储蓄 对话 协商 责任 总需求 教育经费 消耗 审计 供给 宏观调控 优化 贷款 动乱 暴乱 市场调节 销售 住房 案件 产业政策 目的 传统 在于 计划经济 新增 回升 农产品 全民 电子 调整结构 家用 回落 进出口 专业 大体 运行 充分利用 投产 强化 高技术 油田 积压 城乡居民 丰收 人权 开拓 机制 欢迎 步伐 澳门 吸收 集中力量 高新技术 转换 民主监督 贯彻 实力 面向 根本利益 海外侨胞 法规 民族区域 继续加强 社会保障 基础设施 精简 社会化 国有企业 接近 市场经济 进程 设置 特点 达成 国民 国有资产 相当于 避免 政策性 突出 优势 改革方案 减轻 低价 乡镇企业 国债 外资 合法权益 原因 开发区 禁止 财税 增进 保险 市场需求 乱收费 偷税 办学 主体 格局 经济社会 规范 振兴 总体 注重 差距 民主法制 效率 力度 区域 期待 腐败分子 扶贫 公民 调控 分裂 产业 兼并 破产 债务 改组 成立 资本金 查处 征管 负责制 加大 签署 行使主权 分流 树正气 国有经济 压力 资产 宣传 股份合作制 金融危机 防范 长江 停止 金融风险 财政赤字 下岗职工 澳门特别行政区 犯罪 债券 确保 居民 人民币 严禁 关键 产业化 创新 污染 财政政策 金融机构 采伐 趋势 收储 失业 脱困 违法 势头 城镇居民 违纪 手软 发放 旅游 战略性 袭击 台湾同胞 服务业 升级 着力 信息 积极探索 培育 农民收入 自主 节水 宗教 战略目标 监管 竞争力 参与 重组 违规 信息化 足额 农村税费 转移 规则 带动 生态 把握 环境保护 设施 科研机构 公共卫生 疫情 农民工 非公有制 执法 拖欠 医疗卫生 股份制 应对 医疗 补助 统筹 程序 工作者 预防 履行 农业税 预期 专项 经济运行 阶段 进城 务工 支付 事件 遏制 资本 创新能力 救助 知识产权 扶持 服务体系 生产总值 相关 用地 政策措施 减排 过剩 产能 高于 装备 保护环境 实践经验 集约 增幅 同胞 优化结构 民生 免费 排放 依法行政 养老保险 公共服务 覆盖 来自 出台 两岸关系 增速 灾区 拓展 转型 参保 挑战 创业 信心 气候变化 启动 风险 融资 公益性 药物 有序 提升 保障性 结构性 城镇化 低收入 分开 监测 构建 融合 营业税 方案 大病 增值税 安居工程 互联网 货币政策 公平 累计 补偿 框架 权益 退休 权力 居民消费 领导人 贫困地区 区间 地震 法治 淘汰 协同 支撑 利率 事项 设立 核心 民间 深度 海洋 定向 示范区 下放 取消 核准 修订 化解 打造 突破 管理制度 大国 下行 动能 市场化 绿色 脱贫 小康社会 行动 空间 高校 网络 收费 全球 引领 整治 实体 优质 涉企 减税 政务
    


```python
from collections import defaultdict

data = defaultdict(dict)
years = [int(i[:4]) for i in reports]
for i in wordset:
    for year in years:
        data[i][year] = 0
```


```python
for txt in reports:
    year = int(txt[:4])
    top1000= jieba.analyse.textrank(txt, topK=1000, withWeight=True)
    for ww in top1000:
        word, weight = ww
        if word in wordset:
            data[word][year]+= weight
```


```python
word_weight = []
for i in data:
    word_weight.append([i, np.sum(data[i].values())])
```


```python
word_weight.sort(key= lambda x:x[1], reverse = True )
top50 = [i[0] for i in word_weight[:50]]
```


```python
print ' '.join(top50) 
```

    发展 建设 经济 加强 企业 工作 改革 国家 人民 继续 社会主义 提高 社会 生产 农业 政府 制度 增加 推进 问题 促进 增长 加快 农村 方面 管理 进行 重点 坚持 全国 教育 市场 投资 完善 地区 工业 支持 政策 中国 实行 计划 文化 生活 扩大 实现 基本 改善 建立 群众 技术
    


```python

```
